/*
 * This file was automatically generated by EvoSuite
 * Thu Jun 23 13:10:33 GMT 2022
 */

package ir.ramtung.impl1;

import org.junit.Rule;
import org.junit.Test;
import static org.junit.Assert.*;
import static org.evosuite.runtime.EvoAssertions.*;
import ir.ramtung.impl1.Library;
import java.util.List;
import org.evosuite.runtime.EvoRunner;
import org.evosuite.runtime.EvoRunnerParameters;
import org.junit.runner.RunWith;
import ir.ramtung.sts01.LibraryException;



@RunWith(EvoRunner.class) @EvoRunnerParameters(mockJVMNonDeterminism = true, useVFS = true, useVNET = true, resetStaticState = true, separateClassLoader = false, useJEE = true)
public class Library_ESTest extends Library_ESTest_scaffolding {

  @Test(timeout = 4000)
  public void test00()  throws Throwable  {

      Library library0 = new Library();
      library0.addReference((String) "null",  1);
      library0.addProfMember((String) "null");
      library0.borrow((String) "null", (String) "null");
      library0.timePass(8);
      int int0 = library0.getTotalPenalty("null");
      assertEquals(36000,int0);

  }

  @Test(timeout = 4000)
  public void test01()  throws Throwable  {
      Library library0 = new Library();
      try { 
        library0.extend("Cannot extend a late loan", "EvF");
        fail("Expecting exception: Exception");
      
      } catch(Exception e) {
          if (!(e instanceof LibraryException)) {
              fail("Unexpected exception");
          }
         //
         // The document is not in member's loan
         //
         verifyException("ir.ramtung.impl1.Library", e);
      }
  }

  @Test(timeout = 4000)
  public void test02()  throws Throwable  {
      Library library0 = new Library();
      library0.addReference("Cannot find document to borrow", 3735);
      try { 
        library0.borrow(",?1{$L,^", "Cannot find document to borrow");
        fail("Expecting exception: Exception");
      
      } catch(Exception e) {
          if (!(e instanceof LibraryException)) {
              fail("Unexpected exception");
          }
         //
         // Cannot find member to borrow
         //
         verifyException("ir.ramtung.impl1.Library", e);
      }
  }

  @Test(timeout = 4000)
  public void test03()  throws Throwable  {
      Library library0 = new Library();
      library0.addMagazine((String) null, 1210, 338, 2032);
  }

  @Test(timeout = 4000)
  public void test04()  throws Throwable  {
      Library library0 = new Library();
      try { 
        library0.addMagazine("Empty student ID is not allowed", 1, (-3179), 0);
        fail("Expecting exception: Exception");
      
      } catch(Exception e) {
          if (!(e instanceof LibraryException)) {
              fail("Unexpected exception");
          }
         //
         // Magazine with zero or negative number
         //
         verifyException("ir.ramtung.impl1.Magazine", e);
      }
  }

  @Test(timeout = 4000)
  public void test05()  throws Throwable  {
      Library library0 = new Library();
      library0.addStudentMember("p$gz2}K=Q<U", "Cannot extend a late loan");
  }

  @Test(timeout = 4000)
  public void test06()  throws Throwable  {
      Library library0 = new Library();
      library0.addReference((String) "null",  1);
      library0.addProfMember((String) "null");
      library0.borrow((String) "null", (String) "null");
      library0.timePass(10);
      int int0 = library0.getTotalPenalty("null");
      assertEquals(-38000,int0);

  }

  @Test(timeout = 4000)
  public void test07()  throws Throwable  {
      Library library0 = new Library();
      library0.addMagazine((String) null, 589, 589, 589);
      library0.addProfMember((String) null);
      library0.borrow((String) null, (String) null);
      library0.timePass(589);
      int int0 = library0.getTotalPenalty((String) null);
      assertEquals(1174000, int0);

  }

  @Test(timeout = 4000)
  public void test08()  throws Throwable  {
      Library library0 = new Library();
      try { 
        library0.addReference("Nh", (-15));
        fail("Expecting exception: Exception");
      
      } catch(Exception e) {
          if (!(e instanceof LibraryException)) {
              fail("Unexpected exception");
          }
         //
         // Negative or zero copies of a document cannot be added
         //
         verifyException("ir.ramtung.impl1.Library", e);
      }
  }

  @Test(timeout = 4000)
  public void test09()  throws Throwable  {
      Library library0 = new Library();
      try { 
        library0.addProfMember("");
        fail("Expecting exception: Exception");
      
      } catch(Exception e) {
          if (!(e instanceof LibraryException)) {
              fail("Unexpected exception");
          }
         //
         // Empty member name not allowed
         //
         verifyException("ir.ramtung.impl1.Member", e);
      }
  }

  @Test(timeout = 4000)
  public void test10()  throws Throwable  {
      Library library0 = new Library();
      library0.addProfMember("Cannot borrow more documents");
      try { 
        library0.getTotalPenalty("");
        fail("Expecting exception: Exception");
      
      } catch(Exception e) {
          if (!(e instanceof LibraryException)) {
              fail("Unexpected exception");
          }
         //
         // Cannot find member
         //
         verifyException("ir.ramtung.impl1.Library", e);
      }
  }

  @Test(timeout = 4000)
  public void test11()  throws Throwable  {
      Library library0 = new Library();
      library0.addBook((String) null, 1370);
      try { 
        library0.addMagazine((String) null, 1370, 1370, 1370);
        fail("Expecting exception: Exception");
      
      } catch(Exception e) {
          if (!(e instanceof LibraryException)) {
              fail("Unexpected exception");
          }
         //
         // Document with the same title exists
         //
         verifyException("ir.ramtung.impl1.Library", e);
      }
  }

  @Test(timeout = 4000)
  public void test12()  throws Throwable  {
      Library library0 = new Library();
      try { 
        library0.addBook("S>6>U5;IW", 0);
        fail("Expecting exception: Exception");
      
      } catch(Exception e) {
          if (!(e instanceof LibraryException)) {
              fail("Unexpected exception");
          }
         //
         // Negative or zero copies of a document cannot be added
         //
         verifyException("ir.ramtung.impl1.Library", e);
      }
  }

  @Test(timeout = 4000)
  public void test13()  throws Throwable  {
      Library library0 = new Library();
      library0.addMagazine((String) null, 2, 2, 2);
      library0.addProfMember((String) null);
      library0.borrow((String) null, (String) null);
      try { 
        library0.returnDocument((String) null, "9");
        fail("Expecting exception: Exception");
      
      } catch(Exception e) {
          if (!(e instanceof LibraryException)) {
              fail("Unexpected exception");
          }
         //
         // The document is not in member's loan
         //
         verifyException("ir.ramtung.impl1.Library", e);
      }
  }

  @Test(timeout = 4000)
  public void test14()  throws Throwable  {
      Library library0 = new Library();
      library0.addProfMember("ir.ramtung.impl.DuplicatDocumentEx");
      library0.addBook("ir.ramtung.impl.DuplicatDocumentEx", 1101);
      library0.borrow("ir.ramtung.impl.DuplicatDocumentEx", "ir.ramtung.impl.DuplicatDocumentEx");
      try { 
        library0.extend("Cannot etend a ate loan", "Cannot etend a ate loan");
        fail("Expecting exception: Exception");
      
      } catch(Exception e) {
          if (!(e instanceof LibraryException)) {
              fail("Unexpected exception");
          }
         //
         // The document is not in member's loan
         //
         verifyException("ir.ramtung.impl1.Library", e);
      }
  }

  @Test(timeout = 4000)
  public void test15()  throws Throwable  {
      Library library0 = new Library();
      library0.addBook((String) "null",551);
      library0.addProfMember((String) "null");
      library0.borrow((String) "null", (String) "null");
      library0.timePass(17);
      int int0 = library0.getTotalPenalty((String) "null");
      assertEquals(14000, int0);
  }

  @Test(timeout = 4000)
  public void test16()  throws Throwable  {
      Library library0 = new Library();
      try { 
        library0.timePass((-709));
        fail("Expecting exception: Exception");
      
      } catch(Exception e) {
          if (!(e instanceof LibraryException)) {
              fail("Unexpected exception");
          }
         //
         // Cannot go back in time
         //
         verifyException("ir.ramtung.impl1.Library", e);
      }
  }

  @Test(timeout = 4000)
  public void test17()  throws Throwable  {
      Library library0 = new Library();
      library0.addMagazine((String) null, 1, 1, 1);
      library0.addProfMember((String) null);
      library0.borrow((String) null, (String) null);
      List<String> list0 = library0.availableTitles();
      assertTrue(list0.isEmpty());
  }

  @Test(timeout = 4000)
  public void test18()  throws Throwable  {
      Library library0 = new Library();
      library0.addMagazine((String) null, 1, 1, 1);
      List<String> list0 = library0.availableTitles();
      assertFalse(list0.isEmpty());
  }

  @Test(timeout = 4000)
  public void test19()  throws Throwable  {
      Library library0 = new Library();
      library0.addMagazine((String) null, 551, 551, 551);
      library0.addProfMember((String) null);
      library0.borrow((String) null, (String) null);
      library0.borrow((String) null, (String) null);
      library0.borrow((String) null, (String) null);
      library0.borrow((String) null, (String) null);
      library0.borrow((String) null, (String) null);
      try { 
        library0.borrow((String) null, (String) null);
        fail("Expecting exception: Exception");
      
      } catch(Exception e) {
          if (!(e instanceof LibraryException)) {
              fail("Unexpected exception");
          }
         //
         // Cannot borrow more documents
         //
         verifyException("ir.ramtung.impl1.Library", e);
      }
  }

  @Test(timeout = 4000)
  public void test20()  throws Throwable  {
      Library library0 = new Library();
      library0.addMagazine((String) null, 1, 1, 1);
      library0.addProfMember((String) null);
      library0.borrow((String) null, (String) null);
      try { 
        library0.borrow((String) null, (String) null);
        fail("Expecting exception: Exception");
      
      } catch(Exception e) {
          if (!(e instanceof LibraryException)) {
              fail("Unexpected exception");
          }
         //
         // Document is not available to borrow
         //
         verifyException("ir.ramtung.impl1.Library", e);
      }
  }

  @Test(timeout = 4000)
  public void test21()  throws Throwable  {
      Library library0 = new Library();
      try { 
        library0.borrow("", "!QuXev`WX");
        fail("Expecting exception: Exception");
      
      } catch(Exception e) {
          if (!(e instanceof LibraryException)) {
              fail("Unexpected exception");
          }
         //
         // Cannot find document to borrow
         //
         verifyException("ir.ramtung.impl1.Library", e);
      }
  }

  @Test(timeout = 4000)
  public void test22()  throws Throwable  {
      Library library0 = new Library();
      library0.addBook((String) "null",551);
      library0.addProfMember((String) "null");
      library0.borrow((String) "null", (String) "null");
      library0.timePass(31);
      int int0 = library0.getTotalPenalty((String) "null");
      assertEquals(56000, int0);
  }

  @Test(timeout = 4000)
  public void test23()  throws Throwable  {
      Library library0 = new Library();
      library0.addProfMember("ir.ramtung.impl.DuplicatDocumentEx");
      library0.addStudentMember("Cannot etend a ate loan", "Cannot etend a ate loan");
      library0.addBook("ir.ramtung.impl.DuplicatDocumentEx", 1101);
      library0.borrow("ir.ramtung.impl.DuplicatDocumentEx", "ir.ramtung.impl.DuplicatDocumentEx");
      int int0 = library0.getTotalPenalty("Cannot etend a ate loan");
      assertEquals(0, int0);
  }

  @Test(timeout = 4000)
  public void test24()  throws Throwable  {
      Library library0 = new Library();
      library0.addStudentMember("Can7ot extend on the same day borro;ed", "Can7ot extend on the same day borro;ed");
      try { 
        library0.addStudentMember("Can7ot extend on the same day borro;ed", "Can7ot extend on the same day borro;ed");
        fail("Expecting exception: Exception");
      
      } catch(Exception e) {
          if (!(e instanceof LibraryException)) {
              fail("Unexpected exception");
          }
         //
         // Member with the same name exists
         //
         verifyException("ir.ramtung.impl1.Library", e);
      }
  }

    @Test(timeout = 4000)
    public void test25()  throws Throwable  {
        Library library0 = new Library();
        library0.addBook((String) "null",551);
        library0.addProfMember((String) "null");
        library0.borrow((String) "null", (String) "null");
        library0.timePass(60);
        int int0 = library0.getTotalPenalty((String) "null");
        assertEquals(201000, int0);
    }

    @Test(timeout = 4000)
    public void test26()  throws Throwable  {

        Library library0 = new Library();
        library0.addReference((String) "null",  1);
        library0.addProfMember((String) "null");
        library0.borrow((String) "null", (String) "null");
        library0.timePass(2);
        library0.extend("null","null");
        List<String> list0 = library0.availableTitles();
        library0.returnDocument("null","null");
        assertEquals(0,list0.size());
        List<String> list1 = library0.availableTitles();
        assertEquals(1,list1.size());
    }
}
